Index: /trunk/kernel/fs/fatfs.c
===================================================================
--- /trunk/kernel/fs/fatfs.c	(revision 656)
+++ /trunk/kernel/fs/fatfs.c	(revision 657)
@@ -1789,5 +1270,7 @@
     uint32_t   offset    = 0;    // byte offset in page
 
-    mapper_xp = XPTR( local_cxy , mapper );
+    // Two embedded loops to scan the directory mapper:
+    // - scan the parent directory mapper pages 
+    // - scan the directory entries in each 4 Kbytes page
 
     // scan the mapper pages
@@ -1795,5 +1278,5 @@
     {
         // get one page
-        page_xp = mapper_remote_get_page( mapper_xp , page_id );
+        page_xp = mapper_get_page( mapper_xp , page_id );
 
         if( page_xp == XPTR_NULL)
@@ -1804,7 +1287,6 @@
         // get page base
         base_xp = ppm_page2base( page_xp );
-        base    = (uint8_t *)GET_PTR( base_xp );
-
-#if (DEBUG_FATFS_SCAN_DIRECTORY & 0x1)
+
+#if (DEBUG_FATFS_SCAN_DIRECTORY & 1)
 if( DEBUG_FATFS_SCAN_DIRECTORY < cycle )
 mapper_display_page( mapper_xp , page_xp , 256 );
@@ -1813,6 +1295,10 @@
         while( (offset < 4096) && (found == 0) )
         {
-            attr = fatfs_get_record( DIR_ATTR , base + offset );   
-            ord  = fatfs_get_record( LDIR_ORD , base + offset );   
+            // makes a local copy of current directory entry  (32 bytes)
+            hal_remote_memcpy( XPTR( local_cxy , buf ) , base_xp + offset , 32 );
+
+            // get attr and ord from local buffer
+            attr = fatfs_get_record( DIR_ATTR , buf );   
+            ord  = fatfs_get_record( LDIR_ORD , buf );   
 
             if (ord == NO_MORE_ENTRY)                 // no more entry => break
@@ -1832,7 +1318,7 @@
                 seq = ord & 0x3;
                 lfn = (seq > lfn) ? seq : lfn;   
-                if      ( seq == 1 ) fatfs_get_name_from_long( base + offset, lfn1 );
-                else if ( seq == 2 ) fatfs_get_name_from_long( base + offset, lfn2 );
-                else if ( seq == 3 ) fatfs_get_name_from_long( base + offset, lfn3 );
+                if      ( seq == 1 ) fatfs_get_name_from_long( buf , lfn1 );
+                else if ( seq == 2 ) fatfs_get_name_from_long( buf , lfn2 );
+                else if ( seq == 3 ) fatfs_get_name_from_long( buf , lfn3 );
                 offset = offset + 32;
             }
@@ -1842,5 +1328,5 @@
                 if      ( lfn == 0 )
                 {
-                    fatfs_get_name_from_short( base + offset , cname );
+                    fatfs_get_name_from_short( buf , cname );
                 }
                 else if ( lfn == 1 )
@@ -1863,11 +1349,13 @@
                 if ( strcmp( name , cname ) == 0 )
                 {
+                    uint8_t * base = GET_PTR( base_xp );
                     *entry = base + offset;
-                    *index = ((page_id<<12) + offset)>>5; 
-                    found     = 1;
+                    *index = ( (page_id << 12) + offset ) >> 5; 
+                    found  = 1;
                 }
                 offset = offset + 32;
                 lfn    = 0;
             }
+
         }  // end loop on directory entries in page
 
@@ -1881,5 +1369,4 @@
 
 #if DEBUG_FATFS_SCAN_DIRECTORY
-cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_FATFS_SCAN_DIRECTORY < cycle )
 printk("\n[%s]  thread[%x,%x] exit / found child <%s> in <%s>\n",
@@ -1892,5 +1379,4 @@
 
 #if DEBUG_FATFS_SCAN_DIRECTORY
-cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_FATFS_SCAN_DIRECTORY < cycle )
 printk("\n[%s]  thread[%x,%x] exit / child <%s> in <%s> not found\n",
